% match.pl
% matching handling starvars as constant
% calculates a matcher without actually binding the
% variables. Works only for specialized terms (subst-tree application).
% Author: pb

:- module(match,[
	matcher/4,
	matcher/5
]).

:- use_module(substitution).
:- use_module(vars).

matcher(T0,T1,StarVars,M) :-
	matcher(T0,T1,StarVars,[],M).
	
matcher(T0,T1,StarVars,M0,M1) :-
	var(T0),!,
	(var_memberchk(T0,StarVars) ->
	    T0 == T1,
	    M0 = M1
	;
	    M1 = [T0-T1|M0] % P.Graf hat gesaacht des gheert so
	% genauer; T0 kann noch nicht gebunden worden sein und
	% T0 kann nicht in rechten Seiten von M0 vorkommen
	% T1 kann keine linke Seite von M0 enthalten!
	% also --> einfach hinzufuegen
%	    (dom_member(M0,T0,Term) -> % already in matcher
%		matcher(Term,T1,StarVars,M0,M1)
%	    ;
%		add_binding(T0,T1,M0,M1)
%	    )
	).
matcher(T0,T1,StarVars,M0,M1) :-
	nonvar(T1),
	functor(T0,F,A),
	functor(T1,F,A),
	matcher(A,T0,T1,StarVars,M0,M1).

matcher(0,_T1,_T2,_StarVars,M,M) :- !.
matcher(A,T1,T2,StarVars,M0,M2) :- 
	arg(A,T1,ST1),
	arg(A,T2,ST2),
	matcher(ST1,ST2,StarVars,M0,M1),
	A1 is A-1,
	matcher(A1,T1,T2,StarVars,M1,M2).
	

