% variant.pl
% variant for terms with star variables
% V in Definition 5.3.3; P.Graf Diss
% Author: pb

:- module(variant,[
	variant/4
]).


:- use_module(substitution).
:- use_module(subst_tree_match).

variant(Tau,Ro,StarVars,Variant) :-
	variant1(Tau,Ro,StarVars,Variant).
/*
	(variant1(Tau,Ro,StarVars,Variant1) -> 
	    (variant2(Tau,Ro,StarVars,Variant2) ->
		true
	    ;
		write('V1 but not V2'),nl
	    )		
	;
	    (variant2(Tau,Ro,StarVars,Variant2) ->
		write('V2 but not V1 on substs'),nl,
		write('Tau = '),write(Tau),
		write('Ro = '),write(Ro),
		trace,
		(variant1(Tau,Ro,StarVars,_);
		 variant2(Tau,Ro,StarVars,_))
	    ;
		fail
	    )
	),
	length(Variant1,VL1),
	length(Variant2,VL2),
	(VL1 == VL2 ->
	    Variant = Variant2
	;
	    format("~n Variant1 = ~w ~n Variant2 = ~w ~n",[Variant1,Variant2])
	).

*/

variant1(Tau,Ro,StarVars,Variant) :-
	variant1(Tau,Ro,StarVars,[],Variant).

variant1([],_,_StarVars,Variant,Variant).
variant1([V-T|Tau],Ro,StarVars,Variant0,Variant2) :-
	dom_member(Ro,V,TT), % else not matchable
	matcher(T,TT,StarVars,Variant0,Variant1),
	variant1(Tau,Ro,StarVars,Variant1,Variant2).

	

% inefficient, but easy
% We construct a term and match the complete term :-)
variant2(Tau,Ro,StarVars,Variant) :-
	length(Tau,TauLen),
	functor(TauTerm,term,TauLen),
	functor(RoTerm,term,TauLen),
	variant_build_term(Tau,TauTerm,Ro,RoTerm,1),
	matcher(TauTerm,RoTerm,StarVars,Variant).

variant_build_term([],_,_,_,_).
variant_build_term([V-T|Tau],TauTerm,Ro,RoTerm,A) :-
	arg(A,TauTerm,T),
	dom_member(Ro,V,TT), % if none exists not matchable
	arg(A,RoTerm,TT),
	A1 is A + 1,
	variant_build_term(Tau,TauTerm,Ro,RoTerm,A1).

