:- module(terms, [subsumes_chk/2]).

% 
%   term_variables(Term, Variables)
%   True if Variables is the set of variables occurring in Term.
%   Obsolete in SWI-Prolog 5.6.x uh 2008-03-31
%
%term_variables(Term, Variables) :-
%        free_variables(Term, Variables).

%   subsumes_chk(General, Specific)
%   is true when Specific is an instance of General.  It
%   does not bind any variables in General or Specific.

subsumes_chk(General, Specific) :-
        \+ \+ trpMatch(General,Specific).

trpMatch(General,Specific) :-
        var(General),
        var(Specific),
        General = Specific,
        !.
trpMatch(General,Specific) :-
        nonvar(Specific),
        (var(General) ->
            unify_with_occurs_check(General,Specific)
        ;
            functor(General,F,N),
            functor(Specific,F,N),
            trpMatch(N,General,Specific)
        ).

trpMatch(0,_,_) :-
        !.
trpMatch(N,General,Specific) :-
        arg(N,General,GArg),
        arg(N,Specific,SArg),
        trpMatch(GArg,SArg),
        M is N-1,
        trpMatch(M,General,Specific).

